function [bv,idx,time] = BW_All_0(A)

%%%%compute betweenness centrality, using different metrics
c = 0.95;
%%%find the largest connected component
cv = BW_ConnectComp(A);
n0 = max(cv);

for i=1:n0
    len(i) = length(find(cv==i));
end
i0 = find(len==max(len));
i0 = i0(1);

idx = find(cv==i0);
A0 = A(idx,idx);

% work on this largest connected component

tic;
%%degree
bv(:,1) = sum(A0,2);
time(1,1) = toc;
disp('degree over')

% 
% tic;
% %%shortest path
% bv(:,2) = BW_ShortPath(A0);
% time(1,2) = toc;
% disp('shortest path over')
% 
% 
% tic;
% %%Newman's R.W.
% bv(:,3) = BW_RandWalk(A0);
% time(1,3) = toc;
% disp('Newman RW over')
% 
% 
% 
% tic;
% %%RWR
% bv(:,4) = BW_RWR(A0,c);
% time(1,4) = toc;
% disp('rwr over')
% 
% 
% tic;
% %%PageRank
% bv(:,5) = BW_PageRank(A0,c);
% time(1,5) = toc;
% disp('pagerank over')
% 
% tic;
% %%delta lambda_1
% bv(:,6) = BW_Eigs(A0);
% time(1,6) = toc;
% disp('delta lamda_1 over')
% 
% 
% tic;
% %%2nd eigen-vector
% bv(:,7) = BW_EigVec(A0);
% time(1,7) = toc;
% disp('2nd eigen vector over')
% 
% 
% % tic;
% % %%autopart
% % bv(:,8) = BW_AutoPart(A0);
% % time(1,8) = toc;
% % disp('autopart over')
% 
% 
% tic;
% %%abnormality score
% bv(:,8) = TAN_BR(A0,c);
% time(1,8) = toc;
% disp('bridging over')
% 

