function bv = BW_AutoPart(A)


%%%%betweenness centrality by communities (by autopart)

[n,m] = size(A);
[a(:,1),a(:,2),a(:,3)] = find(A);
a(:,3) = 1;

A = sparse(a(:,1),a(:,2),a(:,3),n,n);

%%search community by autopart
[k, l, Nx, Ny, Qx, Qy, Dnz, cA, c2, CAt, C2t] = cc_search(A, 'hellscream', true);

bv = zeros(n,1);
for i=1:k
    pid = find(Qx==i);
    pc(:,i) = sum(A(:,pid),2)/length(pid);%the probability that each node belongs to i^th community
    id = find(pc(:,i));
    bv(id) = bv(id) - pc(id,i) .* log2(pc(id,i));
end
