function [newA, nodes]=GCO_Melt_Nodes(A,k,Method)
%{
 Goal : Melting Graph Nodes 

 Input:
   A:  Graph
   k:  Number of edges 
   Method: Method of selecting edges

 Output:
   newA: New graph after melting
   eiges: Melted edges 

%}

if Method=='NETSHIEL'
    [newA, nodes]=Netshield(A,k,[]);
elseif Method=='NETSHIRE'
    [newA, nodes] = Netshieldplus(A,k,1,[]);
else

c = 0.95;

cv = BW_ConnectComp(A);
n0 = max(cv);

for i=1:n0
    len(i) = length(find(cv==i));
end
i0 = find(len==max(len));
i0 = i0(1);

idx = find(cv==i0);
A0 = A(idx,idx);


if Method=='SUMMATIO'
    bv = sum(A0,2);
elseif Method=='SHORTPAT'
    bv = BW_ShortPath(A0);
elseif Method=='NEWMANRW'
    bv = BW_RandWalk(A0);
elseif Method=='NEWMRWRE'
    bv = BW_RWR(A0,c);
elseif Method=='PAGERANK'
    bv = BW_PageRank(A0,c);
elseif Method=='FRISTEIG'
    bv = BW_Eigs(A0);
elseif Method=='SECONDVE'
    bv = BW_EigVec(A0);
elseif Method=='ABNORMAL'
    bv = TAN_BR(A0,c);
end
[se,index] = sort(bv,'descend');
newA=A;

for kn=1:k
 newA(kn,:)=0;
 newA(:,kn)=0;
 nodes(kn)=index(kn);

end 
end
    
    
end