function [br,Q] = TAN_BR(A,c)

%%%given an adjacency matrix A, compute the bridging score for each nodes
%%%using kensuke's definition
%%%suitable for samll (a few thousand nodes) graphs

A = BLin_W2P(A,0);
n = size(A,1);

Q = inv(eye(n) - c * A);
Q = (triu(Q,1) + tril(Q,-1));
Q = full(Q);
%tic;
for i=1:n
    pos = find(A(:,i));
    if length(pos)<=1%%isolated nodes, or degree-1 ones
        br(i,1) = 0;
    else
        br(i,1) = 1/mean(mean(Q(pos,pos)));
    end    
    %toc;
end

